/*== ECU.H ========================================================================
  
   Vehicle Spy simulation ECU
   
   -------------------------------------------------------------------------------------
   XCP Driver Implementation
   -------------------------------------------------------------------------------------
   Written by Colt R. Correa and Mike Miller
   Copyright (c) 2009 by Intrepid Control Systems
   All Rights Reserved.
   
   -------------------------------------------------------------------------------------
   $Log: ECU.h,v $
   Revision 1.2  2011-04-01 20:04:47  coltc
   saftey updates

   Revision 1.1.1.1  2010-01-13 11:23:16  coltc
   no message

   Revision 1.1  2009-07-02 22:20:29  coltc
   First XCP Driver commit !!!

   Initial revision
  ======================================================================================
*/
/* 
   for this ECU simulation START_ECU_MEMORY must be first.  This is 
   used to determine the start of memory.  
*/
#pragma pack(push)
#pragma pack(1)

#define SIMULATION_MEMORY_START_ADDRESS 0x00081000-4
#define SIMULATION_MEMORY_SIZE 0x2000

typedef struct ECU_MEMORY
{
	unsigned long START_ECU_MEMORY;

	unsigned char Value_BYTE_1;
	unsigned char Value_BYTE_2;

	unsigned char Measurement_BYTE_1;
	unsigned char Measurement_BYTE_2;
		
	short Measurement_SHORT_1;
	short Measurement_SHORT_2;

	short Value_SHORT_1;
	short Value_SHORT_2;

	unsigned char Curve_1_X_Axis[8];
	unsigned char Curve_1_Y_Axis[8];
				   
	unsigned char Map_1_X_Axis[8];
	unsigned char Map_1_Y_Axis[8];
	unsigned char Map_1_Z_Axis[8][8];
};

struct ECU_MEMORY tECU;

unsigned char BUFFER[SIMULATION_MEMORY_SIZE];

#pragma pack(pop)
void InitECU();
void Fire010MSEventECU();
void Fire100MSEventECU();
void Fire500MSEventECU();


