// vspy generated implementation file
#include "vspy.h"
#include "stdarg.h"

unsigned int g_uiHandle;
unsigned char g_bUseExtendedIdBit = 0;
long g_lStartDelay = 0;

#define MIN_VSPY_H_VERSION     1

int getStartDelay()
{
    return g_lStartDelay;
}

void setStartDelay(int delay)
{
    if ((delay < 0) || (delay > 99999))
    {
        Printf("setStartDelay was passed an invalid value: %d\n", delay);
        delay = 0;
    }
    g_lStartDelay = delay;
}

int CM_GetVSPY_C_H_Version()
{
    return MIN_VSPY_H_VERSION;
}

void SetUseExtendedIdBit()
{
    g_bUseExtendedIdBit = 1;
}

int GetMessageName(int iMessageId, int iMessageContext, char * pName, int iBufferSize)
{
    int nLen;
    wchar_t *pWideBuffer = malloc(iBufferSize * sizeof(wchar_t));
    if (isExtId(iMessageId))
        iMessageId = mkStdId(iMessageId);
    if (CM_GetMessageName(g_uiHandle, iMessageId, iMessageContext, pWideBuffer, iBufferSize))
    {
        nLen = WideCharToMultiByte(0, 0, pWideBuffer, (int)wcslen(pWideBuffer), NULL, 0, NULL, NULL);
        WideCharToMultiByte(0, 0, pWideBuffer, (int)wcslen(pWideBuffer), pName, nLen, NULL, NULL);
        pName[nLen] = 0;
        free(pWideBuffer);
        return 1;
    }
    free(pWideBuffer);
    return 0;
}

int GetMessageNameW(int iMessageId, int iMessageContext, wchar_t * pName, int iBufferSize)
{
    if (isExtId(iMessageId))
        iMessageId = mkStdId(iMessageId);
    return CM_GetMessageName(g_uiHandle, iMessageId, iMessageContext, pName, iBufferSize);
}

double AS_Get(int index)
{
    double dTemp;
    CM_GetSetValue(g_uiHandle, CM_GETSET_GET_APP_SIGNAL, index, &dTemp);
    return dTemp;
}

void AS_Set(int index, double dValue)
{
    double dTemp = dValue;
    CM_GetSetValue(g_uiHandle, CM_GETSET_SET_APP_SIGNAL, index, &dTemp);
}

struct AppSigValue
{
    int nOffset;
    double dValue;
};

double AS_GetAt(int index, int element)
{
    struct AppSigValue sVal;
    if (element == 0)
        return AS_Get(index);
    sVal.nOffset = element;
    CM_GetSetValue(g_uiHandle, CM_GETSET_GET_APP_SIGNAL_AT, index, &sVal);
    return sVal.dValue;
}

void AS_SetAt(int index, int element, double dValue)
{
    struct AppSigValue sVal;
    if (element == 0)
    {
        AS_Set(index, dValue);
        return;
    }
    sVal.dValue = dValue;
    sVal.nOffset = element;
    CM_GetSetValue(g_uiHandle, CM_GETSET_SET_APP_SIGNAL_AT, index, &sVal);
}

int AS_GetText(int nIndex, void * szValue, int nLength)
{
    wchar_t szTemp[1024];
    int nLen = nLength;
    CM_GetSetValue(g_uiHandle, CM_GETSET_GET_APP_SIGNAL_TEXT, nIndex, szTemp);
    if (nLen <= 0)
        nLen = min(WideCharToMultiByte(0, 0, szTemp, (int)wcslen(szTemp), NULL, 0, NULL, NULL), 1023);
    if (wcsncmp(szTemp, L"#0x", 3) == 0)  // Binary
    {
        wchar_t szByte[] = L"00";
        int nByte;
        nLen = ((int)wcslen(szTemp) - 3) / 2;
        for (nByte = 0; nByte < nLen; ++nByte)
        {
            szByte[0] = szTemp[3 + nByte * 2];
            szByte[1] = szTemp[4 + nByte * 2];
            *((BYTE *)szValue + nByte) = (BYTE)wcstol(szByte, NULL, 16);
        }
        return nLen;
    }
    WideCharToMultiByte(0, 0, szTemp, (int)wcslen(szTemp), (char *)szValue, nLen, NULL, NULL);
    *((char *)szValue + nLen) = 0;
    return (int)strlen(szValue);
}

int AS_SetText(int nIndex, void * szValue, int nLength)
{
    BOOL bIsBinary = 0;
    wchar_t szTemp[1024];
    int nLen = nLength;
    if (nLen <= 0)
        nLen = min(MultiByteToWideChar(0, 0, (char *)szValue, (int)strlen(szValue), NULL, 0), 1023);
    else
    {
        int nByte;
        wcscpy_s(szTemp, 4, L"#0x");
        for (nByte = 0; nByte < nLength; ++nByte)
        {
            if ((*((BYTE *)szValue) + nByte) < 32)
                bIsBinary = 1;
            swprintf(szTemp + (nByte * 2) + 3, _countof(szTemp) - (nByte * 2) - 3, L"%02x",
                     (*((BYTE *)szValue) + nByte));
        }
    }
    if (bIsBinary)
    {
        CM_GetSetValue(g_uiHandle, CM_GETSET_SET_APP_SIGNAL_TEXT, nIndex, szTemp);
        return nLength;
    }
    else
    {
        MultiByteToWideChar(0, 0, szValue, (int)strlen(szValue), szTemp, nLen);
        szTemp[nLen] = 0;
        CM_GetSetValue(g_uiHandle, CM_GETSET_SET_APP_SIGNAL_TEXT, nIndex, szTemp);
        return (int)strlen(szValue);
    }
}

int AS_GetTextW(int index, wchar_t * szValue)
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_GET_APP_SIGNAL_TEXT, index, szValue);
    return (int)wcslen(szValue);
}

struct AppSigTextValue
{
    int nOffset;
    wchar_t *szValue;
};

int AS_GetTextAtW(int index, int element, wchar_t * szValue)
{
    struct AppSigTextValue sVal;
    sVal.szValue = szValue;
    sVal.nOffset = element;
    CM_GetSetValue(g_uiHandle, CM_GETSET_GET_APP_SIGNAL_TEXT_AT, index, &sVal);
    return (int)wcslen(szValue);
}

int AS_SetTextAtW(int index, int element, wchar_t * szValue)
{
    struct AppSigTextValue sVal;
    sVal.szValue = szValue;
    sVal.nOffset = element;
    CM_GetSetValue(g_uiHandle, CM_GETSET_SET_APP_SIGNAL_TEXT_AT, index, &sVal);
    return (int)wcslen(szValue);
}

int CanNetworksInUse[] = {
    0,  //HS_CAN
    1,  //MS_CAN
};

int Spy_NetworksInUse()
{
    return _countof(CanNetworksInUse);
}

int Spy_TranslateNetwork(int nNetworkOffset)
{
    if ((nNetworkOffset <= 1) || (nNetworkOffset > Spy_NetworksInUse()))
        return CanNetworksInUse[0] + 1;
    else
        return CanNetworksInUse[nNetworkOffset - 1] + 1;
}
int Spy_UntranslateNetwork(int nNetwork)
{
    int can;
    for (can = 0; can < Spy_NetworksInUse(); ++can)
    {
        if (CanNetworksInUse[can] + 1 == nNetwork)
            return can + 1;
    }
    return 1;
}

int Spy_LINIndex(int iNetwork)
{
    return 1;
}

// network index variables - identify networks in vspy
int NET_HS_CAN = 0;
void NET_HS_CAN_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_HS_CAN,0);
}
void NET_HS_CAN_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_HS_CAN,p_NetworkStats);
}
int NET_MS_CAN = 1;
void NET_MS_CAN_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_MS_CAN,0);
}
void NET_MS_CAN_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_MS_CAN,p_NetworkStats);
}
int NET_SW_CAN = 2;
void NET_SW_CAN_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_SW_CAN,0);
}
void NET_SW_CAN_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_SW_CAN,p_NetworkStats);
}
int NET_J1850_VPW = 3;
void NET_J1850_VPW_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_J1850_VPW,0);
}
void NET_J1850_VPW_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_J1850_VPW,p_NetworkStats);
}
int NET_ISO9141_KW2K = 4;
void NET_ISO9141_KW2K_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_ISO9141_KW2K,0);
}
void NET_ISO9141_KW2K_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_ISO9141_KW2K,p_NetworkStats);
}
int NET_LSFT_CAN = 5;
void NET_LSFT_CAN_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_LSFT_CAN,0);
}
void NET_LSFT_CAN_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_LSFT_CAN,p_NetworkStats);
}
int NET_J1850_PWM = 6;
void NET_J1850_PWM_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_J1850_PWM,0);
}
void NET_J1850_PWM_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_J1850_PWM,p_NetworkStats);
}
int NET_J1708 = 7;
void NET_J1708_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_J1708,0);
}
void NET_J1708_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_J1708,p_NetworkStats);
}
int NET_neoVI = 8;
void NET_neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_CLR,NET_neoVI,0);
}
void NET_neoVI_GetStats(NetworkStats * p_NetworkStats)
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_NET_STATS_GET,NET_neoVI,p_NetworkStats);
}

int GenericMessageTransmit(GenericMessage * p_Msg)
{
    int iID;
    int iBitField;
    iID = p_Msg->iID;
    iBitField = p_Msg->iBitField;
    if (isExtId(iID))
    {
        iID = mkStdId(iID);
        iBitField |= ATTR_CAN_29BIT_ID_FRAME;
    }

    return CM_TransmitMessage(g_uiHandle, p_Msg->iNetwork, iID, p_Msg->iNumDataBytes, iBitField, p_Msg->btData);
}

void SpySetTxSignal(unsigned int iMessageIndex, unsigned int iSignalIndex, double dValue)
{
    TxSetSignal txSetSignal;
    txSetSignal.iSignal = iSignalIndex;
    txSetSignal.iType = 0;
    txSetSignal.dValue = dValue;
    CM_GetSetValue(g_uiHandle, CM_GETSET_SET_TXSIGNAL, iMessageIndex, &txSetSignal);
}

void SpySetTxSignalRaw(unsigned int iMessageIndex, unsigned int iSignalIndex, __int64 nValue)
{
    TxSetSignal txSetSignal;
    txSetSignal.iSignal = iSignalIndex;
    txSetSignal.iType = 1;
    txSetSignal.nValue = nValue;
    CM_GetSetValue(g_uiHandle, CM_GETSET_SET_TXSIGNAL, iMessageIndex, &txSetSignal);
}

void SpySetTxEvent(unsigned int iMessageIndex)
{
    TxSetSignal txSetSignal;
    txSetSignal.iType = 2;
    CM_GetSetValue(g_uiHandle, CM_GETSET_SET_TXSIGNAL, iMessageIndex, &txSetSignal);
}

int Spy_TextAPI_W(wchar_t * wcCommand, wchar_t * wcResponse, int iResponseMaxLength)
{
    return CM_TextAPI(g_uiHandle,wcCommand,wcResponse,iResponseMaxLength);
}

int Spy_TextAPI(char * szCommand, char * szResponse, int iResponseMaxLength)
{
    int iCount;
    int iResult;
    wchar_t wcCommand[1024];
    wchar_t wcResponse[1024];
    iCount = MultiByteToWideChar(0, 0, szCommand, (int)strlen(szCommand), NULL, 0);
    MultiByteToWideChar(0, 0, szCommand, (int)strlen(szCommand), wcCommand, iCount);
    wcCommand[iCount] = 0;
    iResult = CM_TextAPI(g_uiHandle, wcCommand, wcResponse, 1024);
    iCount = WideCharToMultiByte(0, 0, wcResponse, (int)wcslen(wcResponse), NULL, 0, NULL, NULL);
    WideCharToMultiByte(0, 0, wcResponse, (int)wcslen(wcResponse), szResponse, iCount, NULL, NULL);
    szResponse[iCount] = 0;
    return iResult;
}

#define MAX_PRINT_BUF_SIZE 1024

int OutputChars(const char *szMsg, int nLen)
{
    wchar_t *pWideBuffer;
    int iCount = MultiByteToWideChar(0, 0, szMsg, nLen, NULL, 0);
    pWideBuffer = malloc((iCount + 1) * sizeof(wchar_t));
    MultiByteToWideChar(0, 0, szMsg, nLen, pWideBuffer, iCount);
    pWideBuffer[iCount] = 0;
    CM_OutputWindow(g_uiHandle, pWideBuffer, 0x0000, 0);
    free(pWideBuffer);
    return iCount;
}

int Printf(const char *szInMsg, ...)
{
    va_list ap;
    int iNumCharacters;
    char szMsg[MAX_PRINT_BUF_SIZE];
    va_start(ap, szInMsg);
    iNumCharacters = vsprintf_s(szMsg, MAX_PRINT_BUF_SIZE, szInMsg, ap);
    iNumCharacters = OutputChars(szMsg, iNumCharacters);
    va_end(ap);
    return iNumCharacters;
}

int PrintfW(const wchar_t *szInMsg, ...)
{
    va_list ap;
    int iNumCharacters;
    wchar_t szMsg[MAX_PRINT_BUF_SIZE];
    va_start(ap, szInMsg);
    iNumCharacters = vswprintf_s(szMsg, MAX_PRINT_BUF_SIZE, szInMsg, ap);
    va_end(ap);
    CM_OutputWindow(g_uiHandle, szMsg, 0x0000, 0);
    return iNumCharacters;
}

int WriteLine(const char *szInMsg, ...)
{
    va_list ap;
    int iNumCharacters;
    char szMsg[MAX_PRINT_BUF_SIZE];
    va_start(ap, szInMsg);
    iNumCharacters = vsprintf_s(szMsg, MAX_PRINT_BUF_SIZE, szInMsg, ap);
    strcat_s(szMsg, MAX_PRINT_BUF_SIZE, "\n");
    ++iNumCharacters;
    iNumCharacters = OutputChars(szMsg, iNumCharacters);
    va_end(ap);
    return iNumCharacters;
}

int WriteLineW(const wchar_t *szInMsg, ...)
{
    va_list ap;
    int iNumCharacters;
    wchar_t szMsg[MAX_PRINT_BUF_SIZE];
    va_start(ap, szInMsg);
    iNumCharacters = vswprintf_s(szMsg, MAX_PRINT_BUF_SIZE, szInMsg, ap);
    va_end(ap);
    wcscat_s(szMsg, MAX_PRINT_BUF_SIZE, L"\n");
    CM_OutputWindow(g_uiHandle, szMsg, 0x0000, 0);
    return iNumCharacters + 1;
}

// Retrieve the system error message for the last error code
void DisplayLastError(LPCWSTR lpszFunction)
{
    LPVOID lpMsgBuf;
    DWORD dw = GetLastError();

    FormatMessageW(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, dw,
                  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPWSTR) &lpMsgBuf, 0, NULL );

    // Display the error message
    if (lpszFunction)
        PrintfW(L"%ls failed with error %d: %ls\n", lpszFunction, dw, lpMsgBuf);
    else
        PrintfW(L"Error %d: %ls\n", dw, lpMsgBuf);

    LocalFree(lpMsgBuf);
}

#define ICS_MAX_RS232_PORT 255
HANDLE hSerialPorts[ICS_MAX_RS232_PORT] = { INVALID_HANDLE_VALUE };

RS232OnRxTx_fdef fptr_ICS_RS232OnSend = NULL;
RS232OnRxTx_fdef fptr_ICS_RS232OnReceive = NULL;
RS232OnError_fdef fptr_ICS_RS232OnError = NULL;

DWORD ICS_RS232Open(DWORD port)
{
    wchar_t szPort[20];
    if ((port <= 0) || (port > ICS_MAX_RS232_PORT))
    {
        PrintfW(L"ICS_RS232Open was passed an invalid port number: %d\n", port);
        return 0;
    }
    wsprintf(szPort, TEXT("\\\\.\\COM%d"), port);
    hSerialPorts[port - 1] = CreateFile(szPort, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hSerialPorts[port - 1] != INVALID_HANDLE_VALUE)
        return 1;
    else
    {
        DisplayLastError(TEXT("ICS_RS232Open"));
        return 0;
    }
}

DWORD ICS_RS232Close(DWORD port)
{
    if ((port <= 0) || (port > ICS_MAX_RS232_PORT))
    {
        PrintfW(L"ICS_RS232Close was passed an invalid port number: %d\n", port);
        return 0;
    }
    if (hSerialPorts[port - 1] != INVALID_HANDLE_VALUE)
    {
        CloseHandle(hSerialPorts[port - 1]);
        hSerialPorts[port - 1] = INVALID_HANDLE_VALUE;
        return 1;
    }
    else
    {
        PrintfW(L"ICS_RS232Close port number %d was not opened\n", port);
        return 0;
    }
}

DWORD ICS_RS232ConfigTimeout(DWORD port, DWORD baudrate, DWORD numberOfDataBits, DWORD numberOfStopBits, DWORD parity, DWORD timeout)
{
    if ((port <= 0) || (port > ICS_MAX_RS232_PORT))
    {
        PrintfW(L"ICS_RS232ConfigTimeout was passed an invalid port number: %d\n", port);
        return 0;
    }
    if (hSerialPorts[port - 1] != INVALID_HANDLE_VALUE)
    {
        DCB comState;
        if (GetCommState(hSerialPorts[port - 1], &comState))
		{
            DCB newComState = comState;

            newComState.BaudRate = baudrate;
            newComState.ByteSize = (BYTE)numberOfDataBits;
            newComState.StopBits = (BYTE)numberOfStopBits;
            newComState.Parity = (BYTE)parity;

            if (SetCommState(hSerialPorts[port - 1], &newComState))
            {
                // Add CommTimeout
                COMMTIMEOUTS commTimeout;
                GetCommTimeouts(hSerialPorts[port - 1], &commTimeout);

                commTimeout.ReadIntervalTimeout = 0;
                commTimeout.ReadTotalTimeoutMultiplier = 0;
                commTimeout.ReadTotalTimeoutConstant = timeout;
                commTimeout.WriteTotalTimeoutMultiplier = 0;
                commTimeout.WriteTotalTimeoutConstant = timeout;

                SetCommTimeouts(hSerialPorts[port - 1], &commTimeout);
                return 1;
            }
            else
            {
                DisplayLastError(TEXT("ICS_RS232Config"));
                hSerialPorts[port - 1] = INVALID_HANDLE_VALUE;
                return 0;
            }
        }
        else
        {
            DisplayLastError(TEXT("ICS_RS232Config"));
            hSerialPorts[port - 1] = INVALID_HANDLE_VALUE; 
            return 0;
        }
    }
    else
    {
        PrintfW(L"ICS_RS232Config port number %d was not opened\n", port); 
        return 0;
    }
}

DWORD ICS_RS232Config(DWORD port, DWORD baudrate, DWORD numberOfDataBits, DWORD numberOfStopBits, DWORD parity)
{
    return ICS_RS232ConfigTimeout(port, baudrate, numberOfDataBits, numberOfStopBits, parity, 10);
}

DWORD ICS_RS232SetHandshake(DWORD port, DWORD handshake, DWORD XonLimit, DWORD XoffLimit, DWORD XonChar, DWORD XoffChar)
{
    if ((port <= 0) || (port > ICS_MAX_RS232_PORT))
    {
        PrintfW(L"ICS_RS232SetHandshake was passed an invalid port number: %d\n", port);
        return 0;
    }
    if (hSerialPorts[port - 1] != INVALID_HANDLE_VALUE)
    {
        DCB comState;
        if (GetCommState(hSerialPorts[port - 1], &comState))
        {
            if (handshake == 128) // Software handshake
            {
                comState.fRtsControl = RTS_CONTROL_HANDSHAKE;
                comState.XonLim = (WORD)XonLimit;
                comState.XoffLim = (WORD)XoffLimit;
                comState.XonChar = (char)XonChar;
                comState.XoffChar = (char)XoffChar;
                if (SetCommState(hSerialPorts[port - 1], &comState))
                    return 1;
                else
                {
                    DisplayLastError(TEXT("RS232SetHandshake"));
                    hSerialPorts[port - 1] = INVALID_HANDLE_VALUE;
                    return 0;
                }
            }
            else
            {
                return 1;
            }
        }
        else
        {
            DisplayLastError(TEXT("ICS_RS232SetHandshake"));
            hSerialPorts[port - 1] = INVALID_HANDLE_VALUE;
            return 0;
        }
    }
    else
    {
        PrintfW(L"ICS_RS232SetHandshake port number %d was not opened\n", port);
        return 0;
    }
}

DWORD ICS_RS232SetSignalLine(DWORD port, DWORD line, DWORD state)
{
    return 0;
}

DWORD ICS_RS232Send(DWORD port, BYTE buffer[], DWORD size)
{
    if ((port <= 0) || (port > ICS_MAX_RS232_PORT))
    {
        PrintfW(L"ICS_RS232Send was passed an invalid port number: %d\n", port);
        return 0;
    }
    if (hSerialPorts[port - 1] != INVALID_HANDLE_VALUE)
    {
        DWORD dwBytesWritten = 0;
        if (WriteFile(hSerialPorts[port - 1], buffer, size, &dwBytesWritten, NULL))
        {
            if (fptr_ICS_RS232OnSend)
                fptr_ICS_RS232OnSend(port, buffer, size);
            return 1;
        }
        else
        {
            DisplayLastError(TEXT("ICS_RS232Send"));
            if (fptr_ICS_RS232OnError)
                fptr_ICS_RS232OnError(port, 0x1);
            return 0;
        }
    }
    else
    {
        PrintfW(L"ICS_RS232Send port number %d was not opened\n", port);
        return 0;
    }
}

DWORD ICS_RS232Receive(DWORD port, BYTE buffer[], DWORD size)
{
    if ((port <= 0) || (port > ICS_MAX_RS232_PORT))
    {
        PrintfW(L"ICS_RS232Receive was passed an invalid port number: %d\n", port);
        return 0;
    }
    if (hSerialPorts[port - 1] != INVALID_HANDLE_VALUE)
    {
        DWORD dwBytesRead = 0;
        if (ReadFile(hSerialPorts[port - 1], buffer, size, &dwBytesRead, NULL))
        {
            if (fptr_ICS_RS232OnReceive)
                fptr_ICS_RS232OnReceive(port, buffer, size);
            return 1;
        }
        else
        {
            DisplayLastError(TEXT("ICS_RS232Receive"));
            if (fptr_ICS_RS232OnError)
                fptr_ICS_RS232OnError(port, 0x2);
            return 0;
        }
    }
    else
    {
        PrintfW(L"ICS_RS232Receive port number %d was not opened\n", port);
        return 0;
    }
}

WORD ICS_RS232WriteByte(DWORD port, DWORD data)
{
    return (WORD)ICS_RS232Send(port, (LPBYTE)&data, 1);
}

WORD ICS_RS232WriteBlock(DWORD port, BYTE buffer[], DWORD size)
{
    return (WORD)ICS_RS232Send(port, buffer, size);
}

void ICS_RS232CloseAllPorts()
{
    int nPort;
    for (nPort = 0; nPort < ICS_MAX_RS232_PORT; ++nPort)
    {
        if (hSerialPorts[nPort] != INVALID_HANDLE_VALUE)
        {
            CloseHandle(hSerialPorts[nPort]);
            hSerialPorts[nPort] = INVALID_HANDLE_VALUE;
        }
    }
    UnloadInpout();
}

HINSTANCE hInpOutDll = NULL;
char bIOErrorDisp = 0;
lpOut32 gfpOut32 = NULL;
lpInp32 gfpInp32 = NULL;
lpIsInpOutDriverOpen gfpIsInpOutDriverOpen = NULL;

void LoadInpOut()
{
    if (hInpOutDll == NULL)
    {
        char szPath[MAX_PATH];
        char *pLastSlash;
        GetModuleFileNameA(NULL, szPath, sizeof(szPath));
        pLastSlash = strrchr(szPath, '\\');
        if (pLastSlash)
            *(pLastSlash + 1) = 0;
        strcat_s(szPath, MAX_PATH, "inpout32.DLL");
        hInpOutDll = LoadLibraryA(szPath);
    }
    if (hInpOutDll == NULL)
    {
        if (bIOErrorDisp == 0)
        {
            PrintfW(L"InpOut32.DLL is not installed!");
            bIOErrorDisp = 1;
        }
    }
    else if (gfpIsInpOutDriverOpen == NULL)
    {
		gfpOut32 = (lpOut32)GetProcAddress(hInpOutDll, "Out32");
		gfpInp32 = (lpInp32)GetProcAddress(hInpOutDll, "Inp32");
		gfpIsInpOutDriverOpen = (lpIsInpOutDriverOpen)GetProcAddress(hInpOutDll, "IsInpOutDriverOpen");
    }
}

void UnloadInpout()
{
    if (hInpOutDll)
    {
        gfpOut32 = NULL;
        gfpInp32 = NULL;
        gfpIsInpOutDriverOpen = NULL;
        FreeLibrary(hInpOutDll);
    }
}

void __stdcall CM_MG_TesterToECU_HS_CAN()
{
    MG_TesterToECU_HS_CAN stMyStruct;
    MG_TesterToECU_HS_CAN_Init(&stMyStruct);
    SpyMsg_MG_TesterToECU_HS_CAN(&stMyStruct);
}

void __stdcall CM_TX_ECU_To_Tester_HS_CAN()
{
    TX_ECU_To_Tester_HS_CAN stMyStruct;
    TX_ECU_To_Tester_HS_CAN_Init(&stMyStruct);
    SpyMsg_TX_ECU_To_Tester_HS_CAN(&stMyStruct);
}

void SpyAppSig_CallAllHandlers()
{
}

void (* CM_RegisterCallback) (unsigned int uiHandle, unsigned short iValueType, unsigned short iIndex, void * pCallBackPointer) ;
void (* CM_GetSetValue) (unsigned int uiHandle, unsigned short iValueType, unsigned short iIndex, void * pValueToSet) ;
int (* CM_TextAPI) (unsigned int uiHandle, wchar_t * pCommand, wchar_t * pResponse, int iResponseMaxLength) ;
int (* CM_FindIndexForObjectFromName) (unsigned int uiHandle, int iObjectType,wchar_t * pName, int * p_iObjectIndex);
int (* CM_GetMessageName) (unsigned int uiHandle, int iMessageId, int iMessageContext, wchar_t * pName, int iBufferSize);
int (* CM_ShowPanel) (unsigned int uiHandle, wchar_t * pWindowName, wchar_t * pPanelName);
int (* CM_SetControlProperty) (unsigned int uiHandle, wchar_t * pPanelName, wchar_t * pWindowName, int prop, void *pValue);
int (* CM_OutputWindow) (unsigned int uiHandle, wchar_t * p_TextToWrite, int iColor, int iLength) ;
int (* CM_TransmitMessage) (unsigned int  uiHandle, int iNetwork,int iID, int iNumDataBytes,int iBitField,unsigned char * p_btData);
int (* CM_GetSignalValue) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,unsigned short iSignalIndex,void * pValueToSet);
int (* CM_TxFromSignals) (unsigned int uiHandle, unsigned short iMessageType,
				       unsigned short iMessageIndex, unsigned char * bt_DefaultBytes, int iByteCount,
				       int iNetworkIndex, void * pSignalValues, int iNumSignalCount);
int (* CM_TxFromRawSignals) (unsigned int uiHandle, unsigned short iMessageType,
				       unsigned short iMessageIndex, unsigned char * bt_DefaultBytes, int iByteCount,
				       int iNetworkIndex, void * pSignalValues, int iNumSignalCount);
int (* CM_MessageGenericInit) (unsigned int uiHandle, unsigned short iMessageType,
					   unsigned short iMessageIndex, void * p_MessageStats, int * p_iNetworkID,
					   int * p_iNumDataBytes, int  p_iNumDataMax, int * p_iPeriodMs, int * p_iID,
					   int * p_iBitField, unsigned char * p_btData, double * p_dSignals, int dSignalMaxCount,
					   int * p_iActualSignalMaxCount,__int64 * p_iTimeStampNanoSecondsHW,unsigned int * p_iTimeStampMillisecondsOS);
int (* CM_MessageRawInit) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
					   uint64 * p_dSignals, int dSignalMaxCount, int * p_iActualSignalMaxCount);
uint64 (* CM_SignalPhysicalToRaw) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
					   unsigned short iSignalIndex, double dPhysicalValue);
int (* CM_UpdateMessageSignalsFromBytes) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                    unsigned char * p_btData, int iNumDataBytes);
int (* CM_UpdateBytesFromSignals) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                    double * p_dSignals, int dSignalMaxCount, unsigned char * p_btData, int iNumDataBytes);
int (* CM_UpdateBytesFromRawSignals) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                    uint64 * p_iSignals, int dSignalMaxCount, unsigned char * p_btData, int iNumDataBytes);
int (* CM_GetEcuCount) (unsigned int uiHandle);
int (* CM_GetMemoryBlockCount) (unsigned int uiHandle, int ecu);
int (* CM_GetMemoryBlockInfo) (unsigned int uiHandle, int ecu, int block, unsigned int *address, unsigned int *size);
int (* CM_GetMemoryBlockData) (unsigned int uiHandle, int ecu, int block, unsigned char *buffer, unsigned int address, unsigned int size);
int (* CM_SetMemoryBlockData) (unsigned int uiHandle, int ecu, int block, unsigned char *buffer, unsigned int address, unsigned int size);

void __stdcall CM_ExtensionInit(unsigned int uiHandle, struct stCallBackPointers  * p_stCallBackPointers)
{
    g_uiHandle = uiHandle;
    // setup the callback function to communicate to the CoreMini
    CM_RegisterCallback = (void ( *)(unsigned int, unsigned short, unsigned short, void *)) p_stCallBackPointers->pRegisterCallBack;
    CM_GetSetValue = (void ( *)(unsigned int , unsigned short, unsigned short, void *)) p_stCallBackPointers->pGetSetValueCallBack; 
    CM_TextAPI = (int ( *)(unsigned int, wchar_t *, wchar_t *, int)) p_stCallBackPointers->pTextAPICallBack;
    CM_FindIndexForObjectFromName = (int ( *)(unsigned int, int, wchar_t *, int *)) p_stCallBackPointers->pFindIndexForObjectFromNameCallBack;
    CM_GetMessageName = (int ( *)(unsigned int uiHandle, int iMessageId, int iMessageContext, wchar_t * pName, int iBufferSize)) p_stCallBackPointers->pGetMessageName;
    CM_ShowPanel = (int ( *)(unsigned int, wchar_t *, wchar_t *)) p_stCallBackPointers->pShowPanelCallBack;
    CM_SetControlProperty = (int ( *)(unsigned int, wchar_t *, wchar_t *, int, void *)) p_stCallBackPointers->pSetControlProp;
    CM_OutputWindow = (int ( *)(unsigned int, wchar_t *, int, int)) p_stCallBackPointers->pOutputWindowCallBack;
    CM_TransmitMessage = (int (* )(unsigned int, int, int, int, int, unsigned char *)) p_stCallBackPointers->pTransmitMessageCallBack  ;
    CM_GetSignalValue = (int (* )(unsigned int, unsigned short, unsigned short, unsigned short, void *)) p_stCallBackPointers->pGetSignalValue;
    CM_TxFromSignals = (int (* )(unsigned int uiHandle, unsigned short iMessageType,
                    unsigned short iMessageIndex, unsigned char * bt_DefaultBytes, int iByteCount,
                    int iNetworkIndex, void * pSignalValues,
                    int iNumSignalCount)) p_stCallBackPointers->pTransmitMessagesFromSignalValues; 
    CM_TxFromRawSignals = (int (* )(unsigned int uiHandle, unsigned short iMessageType,
                    unsigned short iMessageIndex, unsigned char * bt_DefaultBytes, int iByteCount,
                    int iNetworkIndex, void * pSignalValues,
                    int iNumSignalCount)) p_stCallBackPointers->pTransmitMessagesFromRawSignalValues;
    CM_MessageGenericInit = (int (* )(unsigned int uiHandle, unsigned short iMessageType,
                    unsigned short iMessageIndex, void *p_MessageStats, int *p_iNetworkID,
                    int *p_iNumDataBytes, int  p_iNumDataMax, int *p_iPeriodMs, int *p_iID,
                    int *p_iBitField, unsigned char *p_btData, double *p_dSignals, int dSignalMaxCount,
                    int *p_iActualSignalMaxCount, __int64 *p_iTimeStampNanoSecondsHW, unsigned int *p_iTimeStampMillisecondsOS)) p_stCallBackPointers->pMessageGenericInit; 
    CM_MessageRawInit = (int (* )(unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
					   uint64 * p_dSignals, int dSignalMaxCount, int * p_iActualSignalMaxCount)) p_stCallBackPointers->pMessageRawInit;
    CM_SignalPhysicalToRaw = (uint64 (* )(unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
					   unsigned short iSignalIndex, double dPhysicalValue)) p_stCallBackPointers->pSignalPhysicalToRaw;
    CM_UpdateMessageSignalsFromBytes = (int (* )(unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                    unsigned char * p_btData, int iNumDataBytes)) p_stCallBackPointers->pUpdateMessageSignalsFromBytes;
    CM_UpdateBytesFromSignals = (int (* )(unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                    double * p_dSignals, int dSignalMaxCount, unsigned char * p_btData, int iNumDataBytes)) p_stCallBackPointers->pUpdateBytesFromSignals;
    CM_UpdateBytesFromRawSignals = (int (* )(unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                    uint64 * p_iSignals, int dSignalMaxCount, unsigned char * p_btData, int iNumDataBytes)) p_stCallBackPointers->pUpdateBytesFromRawSignals;
    CM_GetEcuCount = (int (* )(unsigned int uiHandle)) p_stCallBackPointers->pGetEcuCount;
    CM_GetMemoryBlockCount = (int (* )(unsigned int uiHandle, int ecu)) p_stCallBackPointers->pGetMemoryBlockCount;
    CM_GetMemoryBlockInfo = (int (* )(unsigned int uiHandle, int ecu, int block, unsigned int *address, unsigned int *size)) p_stCallBackPointers->pGetMemoryBlockInfo;
    CM_GetMemoryBlockData = (int (* )(unsigned int uiHandle, int ecu, int block, unsigned char *buffer, unsigned int address, unsigned int size)) p_stCallBackPointers->pGetMemoryBlockData;
    CM_SetMemoryBlockData = (int (* )(unsigned int uiHandle, int ecu, int block, unsigned char *buffer, unsigned int address, unsigned int size)) p_stCallBackPointers->pSetMemoryBlockData;
    // fix up the index variables by searching for the names
    // network indexes
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"HS CAN",&NET_HS_CAN);
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"MS CAN",&NET_MS_CAN);
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"SW CAN",&NET_SW_CAN);
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"J1850 VPW",&NET_J1850_VPW);
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"ISO9141/KW2K",&NET_ISO9141_KW2K);
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"LSFT CAN",&NET_LSFT_CAN);
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"J1850 PWM",&NET_J1850_PWM);
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"J1708",&NET_J1708);
     CM_FindIndexForObjectFromName(g_uiHandle,0,L"neoVI",&NET_neoVI);

    // database indexes
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message_neoVI",&DB_Report_Message_neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__PWM__neoVI",&DB_Report_Message__PWM__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__GPS_Latitude__neoVI",&DB_Report_Message__GPS_Latitude__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__GPS_Longitude__neoVI",&DB_Report_Message__GPS_Longitude__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__GPS_Flags__neoVI",&DB_Report_Message__GPS_Flags__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__GPS_Altitude__neoVI",&DB_Report_Message__GPS_Altitude__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__GPS_Speed_Bearing__neoVI",&DB_Report_Message__GPS_Speed_Bearing__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__GPS_Accuracy__neoVI",&DB_Report_Message__GPS_Accuracy__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__GPS_Time__neoVI",&DB_Report_Message__GPS_Time__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__WirelessneoVI_Sectors__neoVI",&DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message__WirelessneoVI_Signals__neoVI",&DB_Report_Message__WirelessneoVI_Signals__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message_1_Analog_Card__neoVI",&DB_Report_Message_1_Analog_Card__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message_2_Analog_Card__neoVI",&DB_Report_Message_2_Analog_Card__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message_3_Analog_Card__neoVI",&DB_Report_Message_3_Analog_Card__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Report_Message_4_Analog_Card__neoVI",&DB_Report_Message_4_Analog_Card__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_PLASMA_Time_Resync_neoVI",&DB_PLASMA_Time_Resync_neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_PLASMA_Clock_Edge_neoVI",&DB_PLASMA_Clock_Edge_neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_VNET_A_Stats_neoVI",&DB_VNET_A_Stats_neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_VNET_A_Reboot_neoVI",&DB_VNET_A_Reboot_neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_neoVI_Went_To_Sleep_neoVI",&DB_neoVI_Went_To_Sleep_neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_PLASMA_subsystem_restarted__neoVI",&DB_PLASMA_subsystem_restarted__neoVI_Index);
     CM_FindIndexForObjectFromName(g_uiHandle,1,L"DB_Video_Recording_Report_neoVI",&DB_Video_Recording_Report_neoVI_Index);

    // messages indexes
     CM_FindIndexForObjectFromName(g_uiHandle,2,L"MG_TesterToECU_HS_CAN",&MG_TesterToECU_HS_CAN_Index);

    // tx messages indexes
     CM_FindIndexForObjectFromName(g_uiHandle,3,L"TX_ECU_To_Tester_HS_CAN",&TX_ECU_To_Tester_HS_CAN_Index);

    // function block indexes

    // diagnostic job indexes

    // app signals indexes

    CM_RegisterCallback( g_uiHandle,CM_CALLBACKTYPE_MESSAGE_MG, MG_TesterToECU_HS_CAN_Index,CM_MG_TesterToECU_HS_CAN);
    CM_RegisterCallback( g_uiHandle,CM_CALLBACKTYPE_MESSAGE_TX, TX_ECU_To_Tester_HS_CAN_Index,CM_TX_ECU_To_Tester_HS_CAN);
}
void __stdcall CM_EveryMessage(int iNetwork, int iID, __int64 iTimeStampNanoSecondsHW, unsigned int iTimeStampMillisecondsOS,
									  int iNumDataBytes, int iBitField, unsigned char *p_btData)
{
    GenericMessage stMsg;
    int iCount;
    stMsg.iNetwork = iNetwork;
    stMsg.iID = iID;
    stMsg.iNumDataBytes = iNumDataBytes;
    stMsg.iBitField = iBitField;
    stMsg.iTimeStampMillisecondsOS = iTimeStampMillisecondsOS;
    stMsg.iTimeStampNanoSecondsHW = iTimeStampNanoSecondsHW;
    if (g_bUseExtendedIdBit && (stMsg.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        stMsg.iID = mkExtId(stMsg.iID);
    for (iCount=0;iCount<iNumDataBytes;iCount++)
    {
        stMsg.btData[iCount] = p_btData[iCount];
    }
    Spy_EveryMessage(&stMsg);
}

void Spy_Lock()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_SPY_LOCK,0,0);
}
void Spy_Unlock()
{
    CM_GetSetValue(g_uiHandle,CM_GETSET_SPY_UNLOCK,0,0);
}

void SpyShowPanel(char * pWindowName, char * pPanelName)
{
    wchar_t szWideWindowName[1024];
    wchar_t szWidePanelName[1024];
    int iCount;

    iCount = MultiByteToWideChar(0, 0, pWindowName, (int)strlen(pWindowName), NULL, 0);
    MultiByteToWideChar(0, 0, pWindowName, (int)strlen(pWindowName), szWideWindowName, iCount);
    szWideWindowName[iCount] = 0;

    iCount = MultiByteToWideChar(0, 0, pPanelName, (int)strlen(pPanelName), NULL, 0);
    MultiByteToWideChar(0, 0, pPanelName, (int)strlen(pPanelName), szWidePanelName, iCount);
    szWidePanelName[iCount] = 0;

    // call the api
    CM_ShowPanel(g_uiHandle,szWideWindowName,szWidePanelName);
}

void SpyShowPanelW(wchar_t * pWindowName, wchar_t * pPanelName)
{
    CM_ShowPanel(g_uiHandle,pWindowName,pPanelName);
}

void SpySetControlProperty(char * pPanelName, char * pControlTag, int prop, void *pValue)
{
    wchar_t szWidePanelName[1024];
    wchar_t szWideControlTag[1024];
    int iCount;

    iCount = MultiByteToWideChar(0, 0, pPanelName, (int)strlen(pPanelName), NULL, 0);
    MultiByteToWideChar(0, 0, pPanelName, (int)strlen(pPanelName), szWidePanelName, iCount);
    szWidePanelName[iCount] = 0;

    iCount = MultiByteToWideChar(0, 0, pControlTag, (int)strlen(pControlTag), NULL, 0);
    MultiByteToWideChar(0, 0, pControlTag, (int)strlen(pControlTag), szWideControlTag, iCount);
    szWideControlTag[iCount] = 0;
    if (SPY_CTL_PROP_SET_CAPTION == prop)
    {
        wchar_t szWideValue[1024];
        iCount = MultiByteToWideChar(0, 0, pValue, (int)strlen(pValue), NULL, 0);
        MultiByteToWideChar(0, 0, pValue, (int)strlen(pValue), szWideValue, iCount);
        szWideValue[iCount] = 0;
        CM_SetControlProperty(g_uiHandle, szWidePanelName, szWideControlTag, prop, szWideValue);
    }
    else // call the api
        CM_SetControlProperty(g_uiHandle, szWidePanelName, szWideControlTag, prop, pValue);
}

void SpySetControlPropertyW(wchar_t * pPanelName, wchar_t * pControlTag, int prop, void *pValue)
{
    CM_SetControlProperty(g_uiHandle, pPanelName, pControlTag, prop, pValue);
}

int TX_ECU_To_Tester_HS_CAN_Index = 0;

void TX_ECU_To_Tester_HS_CAN_Init(TX_ECU_To_Tester_HS_CAN * pMsg)
{
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 2, 
    TX_ECU_To_Tester_HS_CAN_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    NULL, 0, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

int TX_ECU_To_Tester_HS_CAN_Transmit(TX_ECU_To_Tester_HS_CAN * pMsg)
{
    return CM_TxFromSignals(g_uiHandle, 2, TX_ECU_To_Tester_HS_CAN_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

int TX_ECU_To_Tester_HS_CAN_Transmit_raw(TX_ECU_To_Tester_HS_CAN * pMsg)
{
    return CM_TxFromRawSignals(g_uiHandle, 2, TX_ECU_To_Tester_HS_CAN_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

int TX_ECU_To_Tester_HS_CAN_TransmitFast()
{
    unsigned char bt_DefaultBytes[8] = {0};
    return CM_TxFromSignals(g_uiHandle,4,TX_ECU_To_Tester_HS_CAN_Index,bt_DefaultBytes,8,0,0,0);
}

void TX_ECU_To_Tester_HS_CAN_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, TX_ECU_To_Tester_HS_CAN_Index, 0);
}

int MG_TesterToECU_HS_CAN_Index = 0;

void MG_TesterToECU_HS_CAN_Init(MG_TesterToECU_HS_CAN * pMsg)
{
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 1, 
    MG_TesterToECU_HS_CAN_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    NULL, 0, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

int MG_TesterToECU_HS_CAN_Transmit(MG_TesterToECU_HS_CAN * pMsg)
{
    return CM_TxFromSignals(g_uiHandle, 1, MG_TesterToECU_HS_CAN_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

int MG_TesterToECU_HS_CAN_Transmit_raw(MG_TesterToECU_HS_CAN * pMsg)
{
    return CM_TxFromRawSignals(g_uiHandle, 1, MG_TesterToECU_HS_CAN_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

void MG_TesterToECU_HS_CAN_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, MG_TesterToECU_HS_CAN_Index, 0);
}

int DB_Report_Message_neoVI_Index = 0;

void DB_Report_Message_neoVI_Init(DB_Report_Message_neoVI * pMsg)
{
    double dValues[14] = {0.0};
    uint64 nRawValues[14] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message_neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 14, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->MISC3_AIN = dValues[0];
    pMsg->MISC4_AIN = dValues[1];
    pMsg->MISC5_AIN = dValues[2];
    pMsg->MISC6_AIN = dValues[3];
    pMsg->MISC1 = dValues[4];
    pMsg->MISC2 = dValues[5];
    pMsg->MISC3 = dValues[6];
    pMsg->MISC4 = dValues[7];
    pMsg->MISC5 = dValues[8];
    pMsg->MISC6 = dValues[9];
    pMsg->LED1 = dValues[10];
    pMsg->LED2 = dValues[11];
    pMsg->LIN1 = dValues[12];
    pMsg->LIN2 = dValues[13];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message_neoVI_Index, nRawValues, 14, &iActualSignalMaxCount);
    pMsg->MISC3_AIN_raw = (BYTE)nRawValues[0];
    pMsg->MISC4_AIN_raw = (BYTE)nRawValues[1];
    pMsg->MISC5_AIN_raw = (BYTE)nRawValues[2];
    pMsg->MISC6_AIN_raw = (BYTE)nRawValues[3];
    pMsg->MISC1_raw = (BYTE)nRawValues[4];
    pMsg->MISC2_raw = (BYTE)nRawValues[5];
    pMsg->MISC3_raw = (BYTE)nRawValues[6];
    pMsg->MISC4_raw = (BYTE)nRawValues[7];
    pMsg->MISC5_raw = (BYTE)nRawValues[8];
    pMsg->MISC6_raw = (BYTE)nRawValues[9];
    pMsg->LED1_raw = (BYTE)nRawValues[10];
    pMsg->LED2_raw = (BYTE)nRawValues[11];
    pMsg->LIN1_raw = (BYTE)nRawValues[12];
    pMsg->LIN2_raw = (BYTE)nRawValues[13];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message_neoVI_LoadSignalValuesArray(DB_Report_Message_neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->MISC3_AIN;
    dArray[1] = pMsg->MISC4_AIN;
    dArray[2] = pMsg->MISC5_AIN;
    dArray[3] = pMsg->MISC6_AIN;
    dArray[4] = pMsg->MISC1;
    dArray[5] = pMsg->MISC2;
    dArray[6] = pMsg->MISC3;
    dArray[7] = pMsg->MISC4;
    dArray[8] = pMsg->MISC5;
    dArray[9] = pMsg->MISC6;
    dArray[10] = pMsg->LED1;
    dArray[11] = pMsg->LED2;
    dArray[12] = pMsg->LIN1;
    dArray[13] = pMsg->LIN2;
}

void DB_Report_Message_neoVI_LoadRawSignalValuesArray(DB_Report_Message_neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->MISC3_AIN_raw;
    nRawValues[1] = pMsg->MISC4_AIN_raw;
    nRawValues[2] = pMsg->MISC5_AIN_raw;
    nRawValues[3] = pMsg->MISC6_AIN_raw;
    nRawValues[4] = pMsg->MISC1_raw;
    nRawValues[5] = pMsg->MISC2_raw;
    nRawValues[6] = pMsg->MISC3_raw;
    nRawValues[7] = pMsg->MISC4_raw;
    nRawValues[8] = pMsg->MISC5_raw;
    nRawValues[9] = pMsg->MISC6_raw;
    nRawValues[10] = pMsg->LED1_raw;
    nRawValues[11] = pMsg->LED2_raw;
    nRawValues[12] = pMsg->LIN1_raw;
    nRawValues[13] = pMsg->LIN2_raw;
}

int DB_Report_Message_neoVI_Transmit(DB_Report_Message_neoVI * pMsg)
{
    double dArray[14];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_neoVI_Init(pMsg);
    }

    DB_Report_Message_neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 14);
}

int DB_Report_Message_neoVI_Transmit_raw(DB_Report_Message_neoVI * pMsg)
{
    uint64 nRawValues[14];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_neoVI_Init(pMsg);
    }

    DB_Report_Message_neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 14);
}

int DB_Report_Message_neoVI_UpdateBytesFromSignals(DB_Report_Message_neoVI * pMsg)
{
    double dArray[14];

    DB_Report_Message_neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message_neoVI_Index, dArray, 14, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message_neoVI_UpdateBytesFromRawSignals(DB_Report_Message_neoVI * pMsg)
{
    uint64 nRawValues[14];

    DB_Report_Message_neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message_neoVI_Index, nRawValues, 14, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message_neoVI_MISC3_AIN_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 0, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC4_AIN_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 1, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC5_AIN_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 2, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC6_AIN_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 3, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC1_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 4, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC2_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 5, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC3_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 6, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC4_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 7, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC5_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 8, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_MISC6_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 9, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_LED1_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 10, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_LED2_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 11, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_LIN1_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 12, dPhysicalValue);
}

BYTE DB_Report_Message_neoVI_LIN2_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_neoVI_Index, 13, dPhysicalValue);
}
void DB_Report_Message_neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message_neoVI_Index, 0);
}

int DB_Report_Message__PWM__neoVI_Index = 1;

void DB_Report_Message__PWM__neoVI_Init(DB_Report_Message__PWM__neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__PWM__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->PWM_In_1 = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__PWM__neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->PWM_In_1_raw = (BYTE)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__PWM__neoVI_LoadSignalValuesArray(DB_Report_Message__PWM__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->PWM_In_1;
}

void DB_Report_Message__PWM__neoVI_LoadRawSignalValuesArray(DB_Report_Message__PWM__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->PWM_In_1_raw;
}

int DB_Report_Message__PWM__neoVI_Transmit(DB_Report_Message__PWM__neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__PWM__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__PWM__neoVI_Init(pMsg);
    }

    DB_Report_Message__PWM__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__PWM__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_Report_Message__PWM__neoVI_Transmit_raw(DB_Report_Message__PWM__neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__PWM__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__PWM__neoVI_Init(pMsg);
    }

    DB_Report_Message__PWM__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__PWM__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_Report_Message__PWM__neoVI_UpdateBytesFromSignals(DB_Report_Message__PWM__neoVI * pMsg)
{
    double dArray[1];

    DB_Report_Message__PWM__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__PWM__neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__PWM__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__PWM__neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_Report_Message__PWM__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__PWM__neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__PWM__neoVI_PWM_In_1_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__PWM__neoVI_Index, 0, dPhysicalValue);
}
void DB_Report_Message__PWM__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__PWM__neoVI_Index, 0);
}

int DB_Report_Message__GPS_Latitude__neoVI_Index = 2;

void DB_Report_Message__GPS_Latitude__neoVI_Init(DB_Report_Message__GPS_Latitude__neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__GPS_Latitude__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Latitude = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__GPS_Latitude__neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->Latitude_raw = (BYTE)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__GPS_Latitude__neoVI_LoadSignalValuesArray(DB_Report_Message__GPS_Latitude__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Latitude;
}

void DB_Report_Message__GPS_Latitude__neoVI_LoadRawSignalValuesArray(DB_Report_Message__GPS_Latitude__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Latitude_raw;
}

int DB_Report_Message__GPS_Latitude__neoVI_Transmit(DB_Report_Message__GPS_Latitude__neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Latitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Latitude__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Latitude__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Latitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_Report_Message__GPS_Latitude__neoVI_Transmit_raw(DB_Report_Message__GPS_Latitude__neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Latitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Latitude__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Latitude__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Latitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_Report_Message__GPS_Latitude__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Latitude__neoVI * pMsg)
{
    double dArray[1];

    DB_Report_Message__GPS_Latitude__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Latitude__neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__GPS_Latitude__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Latitude__neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_Report_Message__GPS_Latitude__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Latitude__neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__GPS_Latitude__neoVI_Latitude_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Latitude__neoVI_Index, 0, dPhysicalValue);
}
void DB_Report_Message__GPS_Latitude__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__GPS_Latitude__neoVI_Index, 0);
}

int DB_Report_Message__GPS_Longitude__neoVI_Index = 3;

void DB_Report_Message__GPS_Longitude__neoVI_Init(DB_Report_Message__GPS_Longitude__neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__GPS_Longitude__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Longitude = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__GPS_Longitude__neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->Longitude_raw = (BYTE)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__GPS_Longitude__neoVI_LoadSignalValuesArray(DB_Report_Message__GPS_Longitude__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Longitude;
}

void DB_Report_Message__GPS_Longitude__neoVI_LoadRawSignalValuesArray(DB_Report_Message__GPS_Longitude__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Longitude_raw;
}

int DB_Report_Message__GPS_Longitude__neoVI_Transmit(DB_Report_Message__GPS_Longitude__neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Longitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Longitude__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Longitude__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Longitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_Report_Message__GPS_Longitude__neoVI_Transmit_raw(DB_Report_Message__GPS_Longitude__neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Longitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Longitude__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Longitude__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Longitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_Report_Message__GPS_Longitude__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Longitude__neoVI * pMsg)
{
    double dArray[1];

    DB_Report_Message__GPS_Longitude__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Longitude__neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__GPS_Longitude__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Longitude__neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_Report_Message__GPS_Longitude__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Longitude__neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__GPS_Longitude__neoVI_Longitude_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Longitude__neoVI_Index, 0, dPhysicalValue);
}
void DB_Report_Message__GPS_Longitude__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__GPS_Longitude__neoVI_Index, 0);
}

int DB_Report_Message__GPS_Flags__neoVI_Index = 4;

void DB_Report_Message__GPS_Flags__neoVI_Init(DB_Report_Message__GPS_Flags__neoVI * pMsg)
{
    double dValues[8] = {0.0};
    uint64 nRawValues[8] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__GPS_Flags__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 8, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Update_Count = dValues[0];
    pMsg->GPS_Date_Available = dValues[1];
    pMsg->GPS_Time_Available = dValues[2];
    pMsg->GPS_Accuracy_Available = dValues[3];
    pMsg->GPS_Bearing_Available = dValues[4];
    pMsg->GPS_Speed_Available = dValues[5];
    pMsg->GPS_Altitude_Available = dValues[6];
    pMsg->GPS_Lat_Lon_Available = dValues[7];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, nRawValues, 8, &iActualSignalMaxCount);
    pMsg->Update_Count_raw = (BYTE)nRawValues[0];
    pMsg->GPS_Date_Available_raw = (BYTE)nRawValues[1];
    pMsg->GPS_Time_Available_raw = (BYTE)nRawValues[2];
    pMsg->GPS_Accuracy_Available_raw = (BYTE)nRawValues[3];
    pMsg->GPS_Bearing_Available_raw = (BYTE)nRawValues[4];
    pMsg->GPS_Speed_Available_raw = (BYTE)nRawValues[5];
    pMsg->GPS_Altitude_Available_raw = (BYTE)nRawValues[6];
    pMsg->GPS_Lat_Lon_Available_raw = (BYTE)nRawValues[7];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__GPS_Flags__neoVI_LoadSignalValuesArray(DB_Report_Message__GPS_Flags__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Update_Count;
    dArray[1] = pMsg->GPS_Date_Available;
    dArray[2] = pMsg->GPS_Time_Available;
    dArray[3] = pMsg->GPS_Accuracy_Available;
    dArray[4] = pMsg->GPS_Bearing_Available;
    dArray[5] = pMsg->GPS_Speed_Available;
    dArray[6] = pMsg->GPS_Altitude_Available;
    dArray[7] = pMsg->GPS_Lat_Lon_Available;
}

void DB_Report_Message__GPS_Flags__neoVI_LoadRawSignalValuesArray(DB_Report_Message__GPS_Flags__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Update_Count_raw;
    nRawValues[1] = pMsg->GPS_Date_Available_raw;
    nRawValues[2] = pMsg->GPS_Time_Available_raw;
    nRawValues[3] = pMsg->GPS_Accuracy_Available_raw;
    nRawValues[4] = pMsg->GPS_Bearing_Available_raw;
    nRawValues[5] = pMsg->GPS_Speed_Available_raw;
    nRawValues[6] = pMsg->GPS_Altitude_Available_raw;
    nRawValues[7] = pMsg->GPS_Lat_Lon_Available_raw;
}

int DB_Report_Message__GPS_Flags__neoVI_Transmit(DB_Report_Message__GPS_Flags__neoVI * pMsg)
{
    double dArray[8];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Flags__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Flags__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 8);
}

int DB_Report_Message__GPS_Flags__neoVI_Transmit_raw(DB_Report_Message__GPS_Flags__neoVI * pMsg)
{
    uint64 nRawValues[8];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Flags__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Flags__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 8);
}

int DB_Report_Message__GPS_Flags__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Flags__neoVI * pMsg)
{
    double dArray[8];

    DB_Report_Message__GPS_Flags__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, dArray, 8, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__GPS_Flags__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Flags__neoVI * pMsg)
{
    uint64 nRawValues[8];

    DB_Report_Message__GPS_Flags__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, nRawValues, 8, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__GPS_Flags__neoVI_Update_Count_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, 0, dPhysicalValue);
}

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Date_Available_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, 1, dPhysicalValue);
}

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Time_Available_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, 2, dPhysicalValue);
}

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Accuracy_Available_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, 3, dPhysicalValue);
}

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Bearing_Available_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, 4, dPhysicalValue);
}

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Speed_Available_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, 5, dPhysicalValue);
}

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Altitude_Available_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, 6, dPhysicalValue);
}

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Lat_Lon_Available_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Flags__neoVI_Index, 7, dPhysicalValue);
}
void DB_Report_Message__GPS_Flags__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__GPS_Flags__neoVI_Index, 0);
}

int DB_Report_Message__GPS_Altitude__neoVI_Index = 5;

void DB_Report_Message__GPS_Altitude__neoVI_Init(DB_Report_Message__GPS_Altitude__neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__GPS_Altitude__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Altitude_Ellipse = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__GPS_Altitude__neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->Altitude_Ellipse_raw = (BYTE)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__GPS_Altitude__neoVI_LoadSignalValuesArray(DB_Report_Message__GPS_Altitude__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Altitude_Ellipse;
}

void DB_Report_Message__GPS_Altitude__neoVI_LoadRawSignalValuesArray(DB_Report_Message__GPS_Altitude__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Altitude_Ellipse_raw;
}

int DB_Report_Message__GPS_Altitude__neoVI_Transmit(DB_Report_Message__GPS_Altitude__neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Altitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Altitude__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Altitude__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Altitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_Report_Message__GPS_Altitude__neoVI_Transmit_raw(DB_Report_Message__GPS_Altitude__neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Altitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Altitude__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Altitude__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Altitude__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_Report_Message__GPS_Altitude__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Altitude__neoVI * pMsg)
{
    double dArray[1];

    DB_Report_Message__GPS_Altitude__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Altitude__neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__GPS_Altitude__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Altitude__neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_Report_Message__GPS_Altitude__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Altitude__neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__GPS_Altitude__neoVI_Altitude_Ellipse_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Altitude__neoVI_Index, 0, dPhysicalValue);
}
void DB_Report_Message__GPS_Altitude__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__GPS_Altitude__neoVI_Index, 0);
}

int DB_Report_Message__GPS_Speed_Bearing__neoVI_Index = 6;

void DB_Report_Message__GPS_Speed_Bearing__neoVI_Init(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg)
{
    double dValues[2] = {0.0};
    uint64 nRawValues[2] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 2, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Speed = dValues[0];
    pMsg->Bearing = dValues[1];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, nRawValues, 2, &iActualSignalMaxCount);
    pMsg->Speed_raw = (BYTE)nRawValues[0];
    pMsg->Bearing_raw = (BYTE)nRawValues[1];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__GPS_Speed_Bearing__neoVI_LoadSignalValuesArray(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Speed;
    dArray[1] = pMsg->Bearing;
}

void DB_Report_Message__GPS_Speed_Bearing__neoVI_LoadRawSignalValuesArray(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Speed_raw;
    nRawValues[1] = pMsg->Bearing_raw;
}

int DB_Report_Message__GPS_Speed_Bearing__neoVI_Transmit(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg)
{
    double dArray[2];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Speed_Bearing__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Speed_Bearing__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 2);
}

int DB_Report_Message__GPS_Speed_Bearing__neoVI_Transmit_raw(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg)
{
    uint64 nRawValues[2];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Speed_Bearing__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Speed_Bearing__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 2);
}

int DB_Report_Message__GPS_Speed_Bearing__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg)
{
    double dArray[2];

    DB_Report_Message__GPS_Speed_Bearing__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, dArray, 2, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__GPS_Speed_Bearing__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg)
{
    uint64 nRawValues[2];

    DB_Report_Message__GPS_Speed_Bearing__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, nRawValues, 2, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__GPS_Speed_Bearing__neoVI_Speed_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, 0, dPhysicalValue);
}

BYTE DB_Report_Message__GPS_Speed_Bearing__neoVI_Bearing_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, 1, dPhysicalValue);
}
void DB_Report_Message__GPS_Speed_Bearing__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__GPS_Speed_Bearing__neoVI_Index, 0);
}

int DB_Report_Message__GPS_Accuracy__neoVI_Index = 7;

void DB_Report_Message__GPS_Accuracy__neoVI_Init(DB_Report_Message__GPS_Accuracy__neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__GPS_Accuracy__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Accuracy = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__GPS_Accuracy__neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->Accuracy_raw = (BYTE)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__GPS_Accuracy__neoVI_LoadSignalValuesArray(DB_Report_Message__GPS_Accuracy__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Accuracy;
}

void DB_Report_Message__GPS_Accuracy__neoVI_LoadRawSignalValuesArray(DB_Report_Message__GPS_Accuracy__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Accuracy_raw;
}

int DB_Report_Message__GPS_Accuracy__neoVI_Transmit(DB_Report_Message__GPS_Accuracy__neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Accuracy__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Accuracy__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Accuracy__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Accuracy__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_Report_Message__GPS_Accuracy__neoVI_Transmit_raw(DB_Report_Message__GPS_Accuracy__neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Accuracy__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Accuracy__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Accuracy__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Accuracy__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_Report_Message__GPS_Accuracy__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Accuracy__neoVI * pMsg)
{
    double dArray[1];

    DB_Report_Message__GPS_Accuracy__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Accuracy__neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__GPS_Accuracy__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Accuracy__neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_Report_Message__GPS_Accuracy__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Accuracy__neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__GPS_Accuracy__neoVI_Accuracy_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Accuracy__neoVI_Index, 0, dPhysicalValue);
}
void DB_Report_Message__GPS_Accuracy__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__GPS_Accuracy__neoVI_Index, 0);
}

int DB_Report_Message__GPS_Time__neoVI_Index = 8;

void DB_Report_Message__GPS_Time__neoVI_Init(DB_Report_Message__GPS_Time__neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__GPS_Time__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Timestamp = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__GPS_Time__neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->Timestamp_raw = (BYTE)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__GPS_Time__neoVI_LoadSignalValuesArray(DB_Report_Message__GPS_Time__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Timestamp;
}

void DB_Report_Message__GPS_Time__neoVI_LoadRawSignalValuesArray(DB_Report_Message__GPS_Time__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Timestamp_raw;
}

int DB_Report_Message__GPS_Time__neoVI_Transmit(DB_Report_Message__GPS_Time__neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Time__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Time__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Time__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Time__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_Report_Message__GPS_Time__neoVI_Transmit_raw(DB_Report_Message__GPS_Time__neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__GPS_Time__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__GPS_Time__neoVI_Init(pMsg);
    }

    DB_Report_Message__GPS_Time__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Time__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_Report_Message__GPS_Time__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Time__neoVI * pMsg)
{
    double dArray[1];

    DB_Report_Message__GPS_Time__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__GPS_Time__neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__GPS_Time__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Time__neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_Report_Message__GPS_Time__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__GPS_Time__neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__GPS_Time__neoVI_Timestamp_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__GPS_Time__neoVI_Index, 0, dPhysicalValue);
}
void DB_Report_Message__GPS_Time__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__GPS_Time__neoVI_Index, 0);
}

int DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index = 9;

void DB_Report_Message__WirelessneoVI_Sectors__neoVI_Init(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg)
{
    double dValues[2] = {0.0};
    uint64 nRawValues[2] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 2, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->WiviStartSector = dValues[0];
    pMsg->WiviEndSector = dValues[1];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, nRawValues, 2, &iActualSignalMaxCount);
    pMsg->WiviStartSector_raw = (BYTE)nRawValues[0];
    pMsg->WiviEndSector_raw = (BYTE)nRawValues[1];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__WirelessneoVI_Sectors__neoVI_LoadSignalValuesArray(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->WiviStartSector;
    dArray[1] = pMsg->WiviEndSector;
}

void DB_Report_Message__WirelessneoVI_Sectors__neoVI_LoadRawSignalValuesArray(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->WiviStartSector_raw;
    nRawValues[1] = pMsg->WiviEndSector_raw;
}

int DB_Report_Message__WirelessneoVI_Sectors__neoVI_Transmit(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg)
{
    double dArray[2];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__WirelessneoVI_Sectors__neoVI_Init(pMsg);
    }

    DB_Report_Message__WirelessneoVI_Sectors__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 2);
}

int DB_Report_Message__WirelessneoVI_Sectors__neoVI_Transmit_raw(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg)
{
    uint64 nRawValues[2];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__WirelessneoVI_Sectors__neoVI_Init(pMsg);
    }

    DB_Report_Message__WirelessneoVI_Sectors__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 2);
}

int DB_Report_Message__WirelessneoVI_Sectors__neoVI_UpdateBytesFromSignals(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg)
{
    double dArray[2];

    DB_Report_Message__WirelessneoVI_Sectors__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, dArray, 2, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__WirelessneoVI_Sectors__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg)
{
    uint64 nRawValues[2];

    DB_Report_Message__WirelessneoVI_Sectors__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, nRawValues, 2, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__WirelessneoVI_Sectors__neoVI_WiviStartSector_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, 0, dPhysicalValue);
}

BYTE DB_Report_Message__WirelessneoVI_Sectors__neoVI_WiviEndSector_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, 1, dPhysicalValue);
}
void DB_Report_Message__WirelessneoVI_Sectors__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index, 0);
}

int DB_Report_Message__WirelessneoVI_Signals__neoVI_Index = 10;

void DB_Report_Message__WirelessneoVI_Signals__neoVI_Init(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg)
{
    double dValues[6] = {0.0};
    uint64 nRawValues[6] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 6, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->WiviJob = dValues[0];
    pMsg->WiviApkResponse = dValues[1];
    pMsg->WiviDataTransferMediumChoice = dValues[2];
    pMsg->WiviApkResponseTo = dValues[3];
    pMsg->WiviReserved0 = dValues[4];
    pMsg->WiviReserved1 = dValues[5];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, nRawValues, 6, &iActualSignalMaxCount);
    pMsg->WiviJob_raw = (BYTE)nRawValues[0];
    pMsg->WiviApkResponse_raw = (BYTE)nRawValues[1];
    pMsg->WiviDataTransferMediumChoice_raw = (BYTE)nRawValues[2];
    pMsg->WiviApkResponseTo_raw = (BYTE)nRawValues[3];
    pMsg->WiviReserved0_raw = (BYTE)nRawValues[4];
    pMsg->WiviReserved1_raw = (BYTE)nRawValues[5];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message__WirelessneoVI_Signals__neoVI_LoadSignalValuesArray(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->WiviJob;
    dArray[1] = pMsg->WiviApkResponse;
    dArray[2] = pMsg->WiviDataTransferMediumChoice;
    dArray[3] = pMsg->WiviApkResponseTo;
    dArray[4] = pMsg->WiviReserved0;
    dArray[5] = pMsg->WiviReserved1;
}

void DB_Report_Message__WirelessneoVI_Signals__neoVI_LoadRawSignalValuesArray(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->WiviJob_raw;
    nRawValues[1] = pMsg->WiviApkResponse_raw;
    nRawValues[2] = pMsg->WiviDataTransferMediumChoice_raw;
    nRawValues[3] = pMsg->WiviApkResponseTo_raw;
    nRawValues[4] = pMsg->WiviReserved0_raw;
    nRawValues[5] = pMsg->WiviReserved1_raw;
}

int DB_Report_Message__WirelessneoVI_Signals__neoVI_Transmit(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg)
{
    double dArray[6];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__WirelessneoVI_Signals__neoVI_Init(pMsg);
    }

    DB_Report_Message__WirelessneoVI_Signals__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 6);
}

int DB_Report_Message__WirelessneoVI_Signals__neoVI_Transmit_raw(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg)
{
    uint64 nRawValues[6];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message__WirelessneoVI_Signals__neoVI_Init(pMsg);
    }

    DB_Report_Message__WirelessneoVI_Signals__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 6);
}

int DB_Report_Message__WirelessneoVI_Signals__neoVI_UpdateBytesFromSignals(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg)
{
    double dArray[6];

    DB_Report_Message__WirelessneoVI_Signals__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, dArray, 6, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message__WirelessneoVI_Signals__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg)
{
    uint64 nRawValues[6];

    DB_Report_Message__WirelessneoVI_Signals__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, nRawValues, 6, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviJob_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, 0, dPhysicalValue);
}

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviApkResponse_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, 1, dPhysicalValue);
}

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviDataTransferMediumChoice_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, 2, dPhysicalValue);
}

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviApkResponseTo_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, 3, dPhysicalValue);
}

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviReserved0_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, 4, dPhysicalValue);
}

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviReserved1_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, 5, dPhysicalValue);
}
void DB_Report_Message__WirelessneoVI_Signals__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message__WirelessneoVI_Signals__neoVI_Index, 0);
}

int DB_Report_Message_1_Analog_Card__neoVI_Index = 11;

void DB_Report_Message_1_Analog_Card__neoVI_Init(DB_Report_Message_1_Analog_Card__neoVI * pMsg)
{
    double dValues[4] = {0.0};
    uint64 nRawValues[4] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message_1_Analog_Card__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 4, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Channel_A = dValues[0];
    pMsg->Channel_B = dValues[1];
    pMsg->Channel_1_Differential_ = dValues[2];
    pMsg->Channel_2_Differential_ = dValues[3];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, nRawValues, 4, &iActualSignalMaxCount);
    pMsg->Channel_A_raw = (BYTE)nRawValues[0];
    pMsg->Channel_B_raw = (BYTE)nRawValues[1];
    pMsg->Channel_1_Differential__raw = (BYTE)nRawValues[2];
    pMsg->Channel_2_Differential__raw = (uint64)nRawValues[3];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message_1_Analog_Card__neoVI_LoadSignalValuesArray(DB_Report_Message_1_Analog_Card__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Channel_A;
    dArray[1] = pMsg->Channel_B;
    dArray[2] = pMsg->Channel_1_Differential_;
    dArray[3] = pMsg->Channel_2_Differential_;
}

void DB_Report_Message_1_Analog_Card__neoVI_LoadRawSignalValuesArray(DB_Report_Message_1_Analog_Card__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Channel_A_raw;
    nRawValues[1] = pMsg->Channel_B_raw;
    nRawValues[2] = pMsg->Channel_1_Differential__raw;
    nRawValues[3] = pMsg->Channel_2_Differential__raw;
}

int DB_Report_Message_1_Analog_Card__neoVI_Transmit(DB_Report_Message_1_Analog_Card__neoVI * pMsg)
{
    double dArray[4];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_1_Analog_Card__neoVI_Init(pMsg);
    }

    DB_Report_Message_1_Analog_Card__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 4);
}

int DB_Report_Message_1_Analog_Card__neoVI_Transmit_raw(DB_Report_Message_1_Analog_Card__neoVI * pMsg)
{
    uint64 nRawValues[4];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_1_Analog_Card__neoVI_Init(pMsg);
    }

    DB_Report_Message_1_Analog_Card__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 4);
}

int DB_Report_Message_1_Analog_Card__neoVI_UpdateBytesFromSignals(DB_Report_Message_1_Analog_Card__neoVI * pMsg)
{
    double dArray[4];

    DB_Report_Message_1_Analog_Card__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, dArray, 4, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message_1_Analog_Card__neoVI_UpdateBytesFromRawSignals(DB_Report_Message_1_Analog_Card__neoVI * pMsg)
{
    uint64 nRawValues[4];

    DB_Report_Message_1_Analog_Card__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, nRawValues, 4, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


BYTE DB_Report_Message_1_Analog_Card__neoVI_Channel_A_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, 0, dPhysicalValue);
}

BYTE DB_Report_Message_1_Analog_Card__neoVI_Channel_B_PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, 1, dPhysicalValue);
}

BYTE DB_Report_Message_1_Analog_Card__neoVI_Channel_1_Differential__PhysicalToRaw(double dPhysicalValue)
{
    return (BYTE )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, 2, dPhysicalValue);
}

uint64 DB_Report_Message_1_Analog_Card__neoVI_Channel_2_Differential__PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_1_Analog_Card__neoVI_Index, 3, dPhysicalValue);
}
void DB_Report_Message_1_Analog_Card__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message_1_Analog_Card__neoVI_Index, 0);
}

int DB_Report_Message_2_Analog_Card__neoVI_Index = 12;

void DB_Report_Message_2_Analog_Card__neoVI_Init(DB_Report_Message_2_Analog_Card__neoVI * pMsg)
{
    double dValues[4] = {0.0};
    uint64 nRawValues[4] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message_2_Analog_Card__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 4, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Channel_3_Differential_ = dValues[0];
    pMsg->Channel_4_Differential_ = dValues[1];
    pMsg->Channel_5_Differential_ = dValues[2];
    pMsg->Channel_6_Differential_ = dValues[3];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, nRawValues, 4, &iActualSignalMaxCount);
    pMsg->Channel_3_Differential__raw = (uint64)nRawValues[0];
    pMsg->Channel_4_Differential__raw = (uint64)nRawValues[1];
    pMsg->Channel_5_Differential__raw = (uint64)nRawValues[2];
    pMsg->Channel_6_Differential__raw = (uint64)nRawValues[3];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message_2_Analog_Card__neoVI_LoadSignalValuesArray(DB_Report_Message_2_Analog_Card__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Channel_3_Differential_;
    dArray[1] = pMsg->Channel_4_Differential_;
    dArray[2] = pMsg->Channel_5_Differential_;
    dArray[3] = pMsg->Channel_6_Differential_;
}

void DB_Report_Message_2_Analog_Card__neoVI_LoadRawSignalValuesArray(DB_Report_Message_2_Analog_Card__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Channel_3_Differential__raw;
    nRawValues[1] = pMsg->Channel_4_Differential__raw;
    nRawValues[2] = pMsg->Channel_5_Differential__raw;
    nRawValues[3] = pMsg->Channel_6_Differential__raw;
}

int DB_Report_Message_2_Analog_Card__neoVI_Transmit(DB_Report_Message_2_Analog_Card__neoVI * pMsg)
{
    double dArray[4];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_2_Analog_Card__neoVI_Init(pMsg);
    }

    DB_Report_Message_2_Analog_Card__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 4);
}

int DB_Report_Message_2_Analog_Card__neoVI_Transmit_raw(DB_Report_Message_2_Analog_Card__neoVI * pMsg)
{
    uint64 nRawValues[4];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_2_Analog_Card__neoVI_Init(pMsg);
    }

    DB_Report_Message_2_Analog_Card__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 4);
}

int DB_Report_Message_2_Analog_Card__neoVI_UpdateBytesFromSignals(DB_Report_Message_2_Analog_Card__neoVI * pMsg)
{
    double dArray[4];

    DB_Report_Message_2_Analog_Card__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, dArray, 4, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message_2_Analog_Card__neoVI_UpdateBytesFromRawSignals(DB_Report_Message_2_Analog_Card__neoVI * pMsg)
{
    uint64 nRawValues[4];

    DB_Report_Message_2_Analog_Card__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, nRawValues, 4, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


uint64 DB_Report_Message_2_Analog_Card__neoVI_Channel_3_Differential__PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, 0, dPhysicalValue);
}

uint64 DB_Report_Message_2_Analog_Card__neoVI_Channel_4_Differential__PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, 1, dPhysicalValue);
}

uint64 DB_Report_Message_2_Analog_Card__neoVI_Channel_5_Differential__PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, 2, dPhysicalValue);
}

uint64 DB_Report_Message_2_Analog_Card__neoVI_Channel_6_Differential__PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_2_Analog_Card__neoVI_Index, 3, dPhysicalValue);
}
void DB_Report_Message_2_Analog_Card__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message_2_Analog_Card__neoVI_Index, 0);
}

int DB_Report_Message_3_Analog_Card__neoVI_Index = 13;

void DB_Report_Message_3_Analog_Card__neoVI_Init(DB_Report_Message_3_Analog_Card__neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message_3_Analog_Card__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Channel_7_Differential_ = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message_3_Analog_Card__neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->Channel_7_Differential__raw = (uint64)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message_3_Analog_Card__neoVI_LoadSignalValuesArray(DB_Report_Message_3_Analog_Card__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Channel_7_Differential_;
}

void DB_Report_Message_3_Analog_Card__neoVI_LoadRawSignalValuesArray(DB_Report_Message_3_Analog_Card__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Channel_7_Differential__raw;
}

int DB_Report_Message_3_Analog_Card__neoVI_Transmit(DB_Report_Message_3_Analog_Card__neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_3_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_3_Analog_Card__neoVI_Init(pMsg);
    }

    DB_Report_Message_3_Analog_Card__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message_3_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_Report_Message_3_Analog_Card__neoVI_Transmit_raw(DB_Report_Message_3_Analog_Card__neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_3_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_3_Analog_Card__neoVI_Init(pMsg);
    }

    DB_Report_Message_3_Analog_Card__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message_3_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_Report_Message_3_Analog_Card__neoVI_UpdateBytesFromSignals(DB_Report_Message_3_Analog_Card__neoVI * pMsg)
{
    double dArray[1];

    DB_Report_Message_3_Analog_Card__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message_3_Analog_Card__neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message_3_Analog_Card__neoVI_UpdateBytesFromRawSignals(DB_Report_Message_3_Analog_Card__neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_Report_Message_3_Analog_Card__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message_3_Analog_Card__neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


uint64 DB_Report_Message_3_Analog_Card__neoVI_Channel_7_Differential__PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_3_Analog_Card__neoVI_Index, 0, dPhysicalValue);
}
void DB_Report_Message_3_Analog_Card__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message_3_Analog_Card__neoVI_Index, 0);
}

int DB_Report_Message_4_Analog_Card__neoVI_Index = 14;

void DB_Report_Message_4_Analog_Card__neoVI_Init(DB_Report_Message_4_Analog_Card__neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Report_Message_4_Analog_Card__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Timestamp = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_Report_Message_4_Analog_Card__neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->Timestamp_raw = (uint64)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Report_Message_4_Analog_Card__neoVI_LoadSignalValuesArray(DB_Report_Message_4_Analog_Card__neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Timestamp;
}

void DB_Report_Message_4_Analog_Card__neoVI_LoadRawSignalValuesArray(DB_Report_Message_4_Analog_Card__neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Timestamp_raw;
}

int DB_Report_Message_4_Analog_Card__neoVI_Transmit(DB_Report_Message_4_Analog_Card__neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_4_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_4_Analog_Card__neoVI_Init(pMsg);
    }

    DB_Report_Message_4_Analog_Card__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Report_Message_4_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_Report_Message_4_Analog_Card__neoVI_Transmit_raw(DB_Report_Message_4_Analog_Card__neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Report_Message_4_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Report_Message_4_Analog_Card__neoVI_Init(pMsg);
    }

    DB_Report_Message_4_Analog_Card__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Report_Message_4_Analog_Card__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_Report_Message_4_Analog_Card__neoVI_UpdateBytesFromSignals(DB_Report_Message_4_Analog_Card__neoVI * pMsg)
{
    double dArray[1];

    DB_Report_Message_4_Analog_Card__neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Report_Message_4_Analog_Card__neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Report_Message_4_Analog_Card__neoVI_UpdateBytesFromRawSignals(DB_Report_Message_4_Analog_Card__neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_Report_Message_4_Analog_Card__neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Report_Message_4_Analog_Card__neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


uint64 DB_Report_Message_4_Analog_Card__neoVI_Timestamp_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Report_Message_4_Analog_Card__neoVI_Index, 0, dPhysicalValue);
}
void DB_Report_Message_4_Analog_Card__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Report_Message_4_Analog_Card__neoVI_Index, 0);
}

int DB_PLASMA_Time_Resync_neoVI_Index = 15;

void DB_PLASMA_Time_Resync_neoVI_Init(DB_PLASMA_Time_Resync_neoVI * pMsg)
{
    double dValues[1] = {0.0};
    uint64 nRawValues[1] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_PLASMA_Time_Resync_neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 1, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Timestamp = dValues[0];
    CM_MessageRawInit(g_uiHandle, 0, DB_PLASMA_Time_Resync_neoVI_Index, nRawValues, 1, &iActualSignalMaxCount);
    pMsg->Timestamp_raw = (uint64)nRawValues[0];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_PLASMA_Time_Resync_neoVI_LoadSignalValuesArray(DB_PLASMA_Time_Resync_neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Timestamp;
}

void DB_PLASMA_Time_Resync_neoVI_LoadRawSignalValuesArray(DB_PLASMA_Time_Resync_neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Timestamp_raw;
}

int DB_PLASMA_Time_Resync_neoVI_Transmit(DB_PLASMA_Time_Resync_neoVI * pMsg)
{
    double dArray[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_PLASMA_Time_Resync_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_PLASMA_Time_Resync_neoVI_Init(pMsg);
    }

    DB_PLASMA_Time_Resync_neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_PLASMA_Time_Resync_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 1);
}

int DB_PLASMA_Time_Resync_neoVI_Transmit_raw(DB_PLASMA_Time_Resync_neoVI * pMsg)
{
    uint64 nRawValues[1];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_PLASMA_Time_Resync_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_PLASMA_Time_Resync_neoVI_Init(pMsg);
    }

    DB_PLASMA_Time_Resync_neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_PLASMA_Time_Resync_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 1);
}

int DB_PLASMA_Time_Resync_neoVI_UpdateBytesFromSignals(DB_PLASMA_Time_Resync_neoVI * pMsg)
{
    double dArray[1];

    DB_PLASMA_Time_Resync_neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_PLASMA_Time_Resync_neoVI_Index, dArray, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_PLASMA_Time_Resync_neoVI_UpdateBytesFromRawSignals(DB_PLASMA_Time_Resync_neoVI * pMsg)
{
    uint64 nRawValues[1];

    DB_PLASMA_Time_Resync_neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_PLASMA_Time_Resync_neoVI_Index, nRawValues, 1, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


uint64 DB_PLASMA_Time_Resync_neoVI_Timestamp_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_PLASMA_Time_Resync_neoVI_Index, 0, dPhysicalValue);
}
void DB_PLASMA_Time_Resync_neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_PLASMA_Time_Resync_neoVI_Index, 0);
}

int DB_PLASMA_Clock_Edge_neoVI_Index = 16;

void DB_PLASMA_Clock_Edge_neoVI_Init(DB_PLASMA_Clock_Edge_neoVI * pMsg)
{
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_PLASMA_Clock_Edge_neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    NULL, 0, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

int DB_PLASMA_Clock_Edge_neoVI_Transmit(DB_PLASMA_Clock_Edge_neoVI * pMsg)
{
    return CM_TxFromSignals(g_uiHandle, 0, DB_PLASMA_Clock_Edge_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

int DB_PLASMA_Clock_Edge_neoVI_Transmit_raw(DB_PLASMA_Clock_Edge_neoVI * pMsg)
{
    return CM_TxFromRawSignals(g_uiHandle, 0, DB_PLASMA_Clock_Edge_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

void DB_PLASMA_Clock_Edge_neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_PLASMA_Clock_Edge_neoVI_Index, 0);
}

int DB_VNET_A_Stats_neoVI_Index = 17;

void DB_VNET_A_Stats_neoVI_Init(DB_VNET_A_Stats_neoVI * pMsg)
{
    double dValues[5] = {0.0};
    uint64 nRawValues[5] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_VNET_A_Stats_neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 5, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->msgTotal = dValues[0];
    pMsg->rxSize = dValues[1];
    pMsg->scCnt = dValues[2];
    pMsg->yields = dValues[3];
    pMsg->bytesRead = dValues[4];
    CM_MessageRawInit(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, nRawValues, 5, &iActualSignalMaxCount);
    pMsg->msgTotal_raw = (uint64)nRawValues[0];
    pMsg->rxSize_raw = (uint64)nRawValues[1];
    pMsg->scCnt_raw = (uint64)nRawValues[2];
    pMsg->yields_raw = (uint64)nRawValues[3];
    pMsg->bytesRead_raw = (uint64)nRawValues[4];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_VNET_A_Stats_neoVI_LoadSignalValuesArray(DB_VNET_A_Stats_neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->msgTotal;
    dArray[1] = pMsg->rxSize;
    dArray[2] = pMsg->scCnt;
    dArray[3] = pMsg->yields;
    dArray[4] = pMsg->bytesRead;
}

void DB_VNET_A_Stats_neoVI_LoadRawSignalValuesArray(DB_VNET_A_Stats_neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->msgTotal_raw;
    nRawValues[1] = pMsg->rxSize_raw;
    nRawValues[2] = pMsg->scCnt_raw;
    nRawValues[3] = pMsg->yields_raw;
    nRawValues[4] = pMsg->bytesRead_raw;
}

int DB_VNET_A_Stats_neoVI_Transmit(DB_VNET_A_Stats_neoVI * pMsg)
{
    double dArray[5];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_VNET_A_Stats_neoVI_Init(pMsg);
    }

    DB_VNET_A_Stats_neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 5);
}

int DB_VNET_A_Stats_neoVI_Transmit_raw(DB_VNET_A_Stats_neoVI * pMsg)
{
    uint64 nRawValues[5];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_VNET_A_Stats_neoVI_Init(pMsg);
    }

    DB_VNET_A_Stats_neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 5);
}

int DB_VNET_A_Stats_neoVI_UpdateBytesFromSignals(DB_VNET_A_Stats_neoVI * pMsg)
{
    double dArray[5];

    DB_VNET_A_Stats_neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, dArray, 5, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_VNET_A_Stats_neoVI_UpdateBytesFromRawSignals(DB_VNET_A_Stats_neoVI * pMsg)
{
    uint64 nRawValues[5];

    DB_VNET_A_Stats_neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, nRawValues, 5, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


uint64 DB_VNET_A_Stats_neoVI_msgTotal_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, 0, dPhysicalValue);
}

uint64 DB_VNET_A_Stats_neoVI_rxSize_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, 1, dPhysicalValue);
}

uint64 DB_VNET_A_Stats_neoVI_scCnt_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, 2, dPhysicalValue);
}

uint64 DB_VNET_A_Stats_neoVI_yields_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, 3, dPhysicalValue);
}

uint64 DB_VNET_A_Stats_neoVI_bytesRead_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_VNET_A_Stats_neoVI_Index, 4, dPhysicalValue);
}
void DB_VNET_A_Stats_neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_VNET_A_Stats_neoVI_Index, 0);
}

int DB_VNET_A_Reboot_neoVI_Index = 18;

void DB_VNET_A_Reboot_neoVI_Init(DB_VNET_A_Reboot_neoVI * pMsg)
{
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_VNET_A_Reboot_neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    NULL, 0, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

int DB_VNET_A_Reboot_neoVI_Transmit(DB_VNET_A_Reboot_neoVI * pMsg)
{
    return CM_TxFromSignals(g_uiHandle, 0, DB_VNET_A_Reboot_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

int DB_VNET_A_Reboot_neoVI_Transmit_raw(DB_VNET_A_Reboot_neoVI * pMsg)
{
    return CM_TxFromRawSignals(g_uiHandle, 0, DB_VNET_A_Reboot_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

void DB_VNET_A_Reboot_neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_VNET_A_Reboot_neoVI_Index, 0);
}

int DB_neoVI_Went_To_Sleep_neoVI_Index = 19;

void DB_neoVI_Went_To_Sleep_neoVI_Init(DB_neoVI_Went_To_Sleep_neoVI * pMsg)
{
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_neoVI_Went_To_Sleep_neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    NULL, 0, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

int DB_neoVI_Went_To_Sleep_neoVI_Transmit(DB_neoVI_Went_To_Sleep_neoVI * pMsg)
{
    return CM_TxFromSignals(g_uiHandle, 0, DB_neoVI_Went_To_Sleep_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

int DB_neoVI_Went_To_Sleep_neoVI_Transmit_raw(DB_neoVI_Went_To_Sleep_neoVI * pMsg)
{
    return CM_TxFromRawSignals(g_uiHandle, 0, DB_neoVI_Went_To_Sleep_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

void DB_neoVI_Went_To_Sleep_neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_neoVI_Went_To_Sleep_neoVI_Index, 0);
}

int DB_PLASMA_subsystem_restarted__neoVI_Index = 20;

void DB_PLASMA_subsystem_restarted__neoVI_Init(DB_PLASMA_subsystem_restarted__neoVI * pMsg)
{
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_PLASMA_subsystem_restarted__neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    NULL, 0, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

int DB_PLASMA_subsystem_restarted__neoVI_Transmit(DB_PLASMA_subsystem_restarted__neoVI * pMsg)
{
    return CM_TxFromSignals(g_uiHandle, 0, DB_PLASMA_subsystem_restarted__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

int DB_PLASMA_subsystem_restarted__neoVI_Transmit_raw(DB_PLASMA_subsystem_restarted__neoVI * pMsg)
{
    return CM_TxFromRawSignals(g_uiHandle, 0, DB_PLASMA_subsystem_restarted__neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, 0, 0);
}

void DB_PLASMA_subsystem_restarted__neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_PLASMA_subsystem_restarted__neoVI_Index, 0);
}

int DB_Video_Recording_Report_neoVI_Index = 21;

void DB_Video_Recording_Report_neoVI_Init(DB_Video_Recording_Report_neoVI * pMsg)
{
    double dValues[9] = {0.0};
    uint64 nRawValues[9] = {0};
    int iActualSignalMaxCount;

    CM_MessageGenericInit(g_uiHandle, 0, 
    DB_Video_Recording_Report_neoVI_Index, &pMsg->Statistics, &pMsg->MessageData.iNetwork, 
    &pMsg->MessageData.iNumDataBytes, sizeof(pMsg->MessageData.btData),
    &pMsg->iDefaultPeriodMilliseconds, &pMsg->MessageData.iID,
    &pMsg->MessageData.iBitField, &pMsg->MessageData.btData[0],
    &dValues[0], 9, // number of signals when vspy.h was generated
    &iActualSignalMaxCount, &pMsg->MessageData.iTimeStampNanoSecondsHW, &pMsg->MessageData.iTimeStampMillisecondsOS);
    memcpy(pMsg->MessageData.btInitialData, pMsg->MessageData.btData, sizeof(pMsg->MessageData.btData));
    pMsg->Recording_in_progress = dValues[0];
    pMsg->FPGA_Com_Alive = dValues[1];
    pMsg->Bad_Chip = dValues[2];
    pMsg->uBLogTOCnt = dValues[3];
    pMsg->FPGAComTOCnt = dValues[4];
    pMsg->SockConfigTOCnt = dValues[5];
    pMsg->SockActivityTOCnt = dValues[6];
    pMsg->SockDisconCnt = dValues[7];
    pMsg->WcfSM = dValues[8];
    CM_MessageRawInit(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, nRawValues, 9, &iActualSignalMaxCount);
    pMsg->Recording_in_progress_raw = (uint64)nRawValues[0];
    pMsg->FPGA_Com_Alive_raw = (uint64)nRawValues[1];
    pMsg->Bad_Chip_raw = (uint64)nRawValues[2];
    pMsg->uBLogTOCnt_raw = (uint64)nRawValues[3];
    pMsg->FPGAComTOCnt_raw = (uint64)nRawValues[4];
    pMsg->SockConfigTOCnt_raw = (uint64)nRawValues[5];
    pMsg->SockActivityTOCnt_raw = (uint64)nRawValues[6];
    pMsg->SockDisconCnt_raw = (uint64)nRawValues[7];
    pMsg->WcfSM_raw = (uint64)nRawValues[8];
    if (g_bUseExtendedIdBit && (pMsg->MessageData.iBitField & ATTR_CAN_29BIT_ID_FRAME))
        pMsg->MessageData.iID = mkExtId(pMsg->MessageData.iID);
}

void DB_Video_Recording_Report_neoVI_LoadSignalValuesArray(DB_Video_Recording_Report_neoVI * pMsg, double *dArray)
{
    dArray[0] = pMsg->Recording_in_progress;
    dArray[1] = pMsg->FPGA_Com_Alive;
    dArray[2] = pMsg->Bad_Chip;
    dArray[3] = pMsg->uBLogTOCnt;
    dArray[4] = pMsg->FPGAComTOCnt;
    dArray[5] = pMsg->SockConfigTOCnt;
    dArray[6] = pMsg->SockActivityTOCnt;
    dArray[7] = pMsg->SockDisconCnt;
    dArray[8] = pMsg->WcfSM;
}

void DB_Video_Recording_Report_neoVI_LoadRawSignalValuesArray(DB_Video_Recording_Report_neoVI * pMsg, uint64 *nRawValues)
{
    nRawValues[0] = pMsg->Recording_in_progress_raw;
    nRawValues[1] = pMsg->FPGA_Com_Alive_raw;
    nRawValues[2] = pMsg->Bad_Chip_raw;
    nRawValues[3] = pMsg->uBLogTOCnt_raw;
    nRawValues[4] = pMsg->FPGAComTOCnt_raw;
    nRawValues[5] = pMsg->SockConfigTOCnt_raw;
    nRawValues[6] = pMsg->SockActivityTOCnt_raw;
    nRawValues[7] = pMsg->SockDisconCnt_raw;
    nRawValues[8] = pMsg->WcfSM_raw;
}

int DB_Video_Recording_Report_neoVI_Transmit(DB_Video_Recording_Report_neoVI * pMsg)
{
    double dArray[9];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Video_Recording_Report_neoVI_Init(pMsg);
    }

    DB_Video_Recording_Report_neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_TxFromSignals(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, dArray, 9);
}

int DB_Video_Recording_Report_neoVI_Transmit_raw(DB_Video_Recording_Report_neoVI * pMsg)
{
    uint64 nRawValues[9];
    if (memcmp(pMsg->MessageData.btData, pMsg->MessageData.btInitialData, sizeof(pMsg->MessageData.btData)))
    {
        CM_UpdateMessageSignalsFromBytes(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
        DB_Video_Recording_Report_neoVI_Init(pMsg);
    }

    DB_Video_Recording_Report_neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_TxFromRawSignals(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes, pMsg->MessageData.iNetwork, nRawValues, 9);
}

int DB_Video_Recording_Report_neoVI_UpdateBytesFromSignals(DB_Video_Recording_Report_neoVI * pMsg)
{
    double dArray[9];

    DB_Video_Recording_Report_neoVI_LoadSignalValuesArray(pMsg, dArray);

    return CM_UpdateBytesFromSignals(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, dArray, 9, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}

int DB_Video_Recording_Report_neoVI_UpdateBytesFromRawSignals(DB_Video_Recording_Report_neoVI * pMsg)
{
    uint64 nRawValues[9];

    DB_Video_Recording_Report_neoVI_LoadRawSignalValuesArray(pMsg, nRawValues);

    return CM_UpdateBytesFromRawSignals(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, nRawValues, 9, pMsg->MessageData.btData, pMsg->MessageData.iNumDataBytes);
}


uint64 DB_Video_Recording_Report_neoVI_Recording_in_progress_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 0, dPhysicalValue);
}

uint64 DB_Video_Recording_Report_neoVI_FPGA_Com_Alive_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 1, dPhysicalValue);
}

uint64 DB_Video_Recording_Report_neoVI_Bad_Chip_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 2, dPhysicalValue);
}

uint64 DB_Video_Recording_Report_neoVI_uBLogTOCnt_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 3, dPhysicalValue);
}

uint64 DB_Video_Recording_Report_neoVI_FPGAComTOCnt_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 4, dPhysicalValue);
}

uint64 DB_Video_Recording_Report_neoVI_SockConfigTOCnt_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 5, dPhysicalValue);
}

uint64 DB_Video_Recording_Report_neoVI_SockActivityTOCnt_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 6, dPhysicalValue);
}

uint64 DB_Video_Recording_Report_neoVI_SockDisconCnt_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 7, dPhysicalValue);
}

uint64 DB_Video_Recording_Report_neoVI_WcfSM_PhysicalToRaw(double dPhysicalValue)
{
    return (uint64 )CM_SignalPhysicalToRaw(g_uiHandle, 0, DB_Video_Recording_Report_neoVI_Index, 8, dPhysicalValue);
}
void DB_Video_Recording_Report_neoVI_ClearStats()
{
    CM_GetSetValue(g_uiHandle, CM_GETSET_TX_STATS_CLR, DB_Video_Recording_Report_neoVI_Index, 0);
}
